n, q, k = map(int, input().split())
priorities = list(map(int, input().split()))
order = list(range(1, n + 1))
for _ in range(q):
    l, r = map(int, input().split())
    temp = [(priorities[i], order[i]) for i in range(l - 1, r)]
    temp.sort()
    for i in range(l - 1, r):
        order[i] = temp[i - l + 1][1]
print(order[k - 1])
